/* ``The contents of this file are subject to the Erlang Public License,
 * Version 1.0, (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.erlang.org/EPL1_0.txt
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Erlang-4.7.3, December, 1998.
 * 
 * The Initial Developer of the Original Code is Ericsson Telecom
 * AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
 * Telecom AB. All Rights Reserved.
 * 
 * Contributor(s): ______________________________________.''
 */
#include "ei.h"
#include "putget.h"

int ei_decode_list_header(const char *buf, int *index, int *arity)
{
  const char *s = buf + *index;
  const char *s0 = s;

  switch (get8(s)) {
  case ERL_NIL_EXT:
    if (arity) *arity = 0;
    break;
    
  case ERL_LIST_EXT:
    if (arity) *arity = get32be(s);
    else s+= 4;
    break;

  default:
    return -1;
  }
  
  *index += s-s0; 

  return 0;
}
